unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX, IniFiles;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;

implementation

uses
  U_DataLink, U_iniParam, U_WarpBeamInfoList, U_WarpBeamInList,
  U_WarpBeamOutList, U_WarpBeamStkList, U_WBSpecList, U_TatWBPlanCard,
  U_EmptyBeamInList, U_EmptyBeamOutList, U_EmptyBeamStkList, U_TatWBOutputList,
  U_TatWBOutputList1, U_WarpBeamQianList, U_TatWBOutputList_CZ,
  U_TatWBOutputList_SZ, U_TatWBOutputList_JT, U_TatWBOutputList_XB,
  U_TatWBOutputList_XZ, U_TatOutputList1, U_TatWBPlan, U_TatWBNeedList,
  U_TatWBPlanZJZK,U_WBNeedHTList;



       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;
  SetLength(fDllFileName, 255);
  GetModuleFileName(HInstance, PChar(fDllFileName), Length(fDllFileName));
  fDllFileName := ExtractFileName(PChar(fDllFileName));
  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if trim(DataBaseStr) = '' then
  begin
    server := '150.109.121.232,7781';
//    server := '150.109.121.232,1023';
    dtbase := 'KaiXiYadata';
    user := 'kaixiyasa';
    pswd := 'rightsoft,.KXY@YN';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
    Parameters1 := '管理';
    Parameters2 := '空轴';
    Parameters2 := '经轴';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;
  if IsINIFile() then
    ReadINIFile()
  else
    WriteINIFile;
  GetsysParam('', '');
   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  bFound := False;
  if FormID <> 10000 then
  begin
    for i := 0 to Application.MainForm.MDIChildCount - 1 do
    begin
      if Application.MainForm.MDIChildren[i].Caption = Title then
      begin
        mnewHandle := Application.MainForm.MDIChildren[i].Handle;
        Application.MainForm.MDIChildren[i].BringToFront;
        bFound := True;
        Result := mnewHandle;
        exit;
      end;
    end;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of

    511:  //浆纱计划管理
      begin
        with TfrmTatWBPlan.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    521:  //浆纱产量管理
      begin
        with TfrmTatOutputList1.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    111:  //盘头名称定义   轴管编号
      begin
        with TfrmWarpBeamInfoList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    112:  //整经工艺管理
      begin
        with TfrmWBSpecList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

//    113:  //轴卡管理
//      begin
//        with TfrmTatWBPlanCard.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
//        begin
//          fFormID := FormID;
//          FormStyle := mstyle;
//          WindowState := mstate;
//          BorderStyle := mborderstyle;
//          mnewHandle := Handle;
//        end;
//      end;

    113:  //轴卡管理
      begin
        with TfrmTatWBPlanZJZK.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    121:  //整经产量管理
      begin
        with TfrmTatWBOutputList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    122:  //经轴加工采购产量
      begin
        with TfrmTatWBOutputList1.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    131:  //经轴需求统计
      begin
        with TfrmTatWBNeedList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
    132:  //经轴需求统计（合同）
      begin
        with TfrmWBNeedHTList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    211:  //经轴入库
      begin
        with TfrmWarpBeamInList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    221:  //经轴出库
      begin
        with TfrmWarpBeamOutList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    231:  //经轴库存
      begin
        with TfrmWarpBeamStkList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    241:  //外欠盘头
      begin
        with TfrmWarpBeamQianList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    311:  //空轴入库
      begin
        with TfrmEmptyBeamInList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    321:  //空轴出库
      begin
        with TfrmEmptyBeamOutList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    331:  //空轴库存
      begin
        with TfrmEmptyBeamStkList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    421:  //穿综产量管理
      begin
        with TfrmTatWBOutputList_CZ.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    431:  //接头产量管理
      begin
        with TfrmTatWBOutputList_JT.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    441:  //上轴产量管理
      begin
        with TfrmTatWBOutputList_SZ.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    451:  //下布产量管理
      begin
        with TfrmTatWBOutputList_XB.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    461:  //下轴产量管理
      begin
        with TfrmTatWBOutputList_XZ.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;

    10000:
      begin
        for i := 0 to application.MainForm.MDIChildCount - 1 do
        begin
          if application.MainForm.MDIChildren[i].Caption = Title then
          begin
            application.MainForm.MDIChildren[i].Close;
          end;
        end;
      end;
  end;

  Result := mnewHandle;
end;

function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;
begin
  result := true;
  //////////////////////////////
//  shortDateFormat := 'yyyy-MM-dd';
  //服务器日期
  with DataLink_WarpBeamStk.AdoDataLink do
  begin
    close;
    sql.Clear;
    sql.Add('select getDate()as dt');
    open;
    DServerDate := fieldByName('dt').AsDatetime;
  end;
  result := true;
end;

//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_WarpBeamStk) then
    DataLink_WarpBeamStk := TDataLink_WarpBeamStk.Create(Application);
  try
    with DataLink_WarpBeamStk.ADOLink do
    begin
      if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_WarpBeamStk.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

